package edu.uiuc.edsg;

import edu.uiuc.edsg.Wrapper;

public class ConversionWrapper<FromType, ToType> extends Wrapper<ToType> {
	private IGenerator<FromType> _target;
	private Converter<FromType, ToType> _converter;
	
	public ConversionWrapper(IGenerator<FromType> target, Converter<FromType, ToType> converter) {
		super(target);
		_target = target;
		_converter = converter;
	}
	
	@Override
	protected ToType getDependentValue() {
		return _converter.convert(_target.current());
	}
}
